// RM script of Kashmir by AOE_Fan aka Aoe3_Badger
// Credit of the idea to Pepp
// Main entry point for random map script
//
include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{
   // Text
   // Make the loading bar move
   rmSetStatusText("",0.01);


   // Chooses the 4 natives - Bhakti, Sufi or Udasi randomly
   int subCiv0=-1;
   int subCiv1=-1;
   int subCiv2=-1;
   int subCiv3=-1;
   int nativeInt1 = rmRandInt(1,3);
   int nativeInt2 = rmRandInt(1,3);
   int nativeInt3 = rmRandInt(1,3);
   int nativeInt4 = rmRandInt(1,3);
   if (rmAllocateSubCivs(4) == true)
   {
      // Native 1
      if (nativeInt1 == 1)
      {
            subCiv0=rmGetCivID("Bhakti");
	    if (subCiv0 >= 0)
                        rmSetSubCiv(0, "Bhakti", true);
      }
      else if (nativeInt1 == 2)
      {
            subCiv0=rmGetCivID("Sufi");
            if (subCiv0 >= 0)
                        rmSetSubCiv(0, "Sufi", true);
      }
      else if (nativeInt1 == 3)
      {
            subCiv0=rmGetCivID("Udasi");
            if (subCiv0 >= 0)
                        rmSetSubCiv(0, "Udasi", true);
      }

      // Native 2
      if (nativeInt2 == 1)
      {	 
            subCiv1=rmGetCivID("Udasi");
            if (subCiv1 >= 0)
                        rmSetSubCiv(1, "Udasi");
      }
      else if (nativeInt2 == 2)
      {
            subCiv1=rmGetCivID("Bhakti");
            if (subCiv1 >= 0)
                        rmSetSubCiv(1, "Bhakti");
      }
      else if (nativeInt2 == 3)
      {
            subCiv1=rmGetCivID("Sufi");
            if (subCiv1 >= 0)
                        rmSetSubCiv(1, "Sufi");
      }

      // Native 3
      if (nativeInt3 == 1)
      {	 
            subCiv2=rmGetCivID("Sufi");
            if (subCiv2 >= 0)
                        rmSetSubCiv(2, "Sufi");
      }
      else if (nativeInt3 == 2)
      {
            subCiv2=rmGetCivID("Udasi");
            if (subCiv2 >= 0)
                        rmSetSubCiv(2, "Udasi");
      }
      else if (nativeInt3 == 3)
      {
            subCiv2=rmGetCivID("Bhakti");
            if (subCiv2 >= 0)
                        rmSetSubCiv(2, "Bhakti");
      }

      // Native 4
      if (nativeInt4 == 1)
      {
            subCiv3=rmGetCivID("Bhakti");
	    if (subCiv3 >= 0)
                        rmSetSubCiv(3, "Bhakti");
      }
      else if (nativeInt4 == 2)
      {
            subCiv3=rmGetCivID("Sufi");
            if (subCiv3 >= 0)
                        rmSetSubCiv(3, "Sufi");
      }
      else if (nativeInt4 == 3)
      {
            subCiv3=rmGetCivID("Udasi");
            if (subCiv3 >= 0)
                        rmSetSubCiv(3, "Udasi");
      }
   }


   // Picks the map size
   int playerTiles = 18000;
   if (cNumberNonGaiaPlayers == 2)
      playerTiles = 18000;
   if (cNumberNonGaiaPlayers >4)
      playerTiles = 16000;
   if (cNumberNonGaiaPlayers >6)
      playerTiles = 14000;		

   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);
	

   // Set map the map smoothness
   rmSetMapElevationHeightBlend(1);


   // Chooses the starting area animals
   int startAnimal = rmRandInt(1,3);


   // Chooses the pond where the 4th native starts near to
   int nearPond = rmRandInt(1,3);


   // Chooses the places of ponds, W-E, NW-SE, N-S, NE-SW (W=West, E=East, N=North, S=South)
   int pondPlace = rmRandInt(1,4);


   // Picks a default water height
   rmSetSeaLevel(-4.0);


   // Pick lighting
   rmSetLightingSet("Carolina");


   // Picks default terrain and map type
   rmSetMapElevationParameters(cElevTurbulence, 0.07, 4, 0.5, 5.0);
   rmSetBaseTerrainMix("himalayas_a");
   rmTerrainInitialize("Himalayas\cliff_himal_top", 4.0);
   rmSetMapType("borneo");
   rmSetMapType("grass");
   rmSetMapType("land");

   chooseMercs();


   // Corner constraint
   rmSetWorldCircleConstraint(true);


   // Define classes, these are used for constraints
   int classPlayer=rmDefineClass("player");
   int classAnimals=rmDefineClass("animals");
   int classCliff=rmDefineClass("cliff");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
   rmDefineClass("nuggets");
   rmDefineClass("center");
   rmDefineClass("natives");


   // Define constraints
   // These are used to have objects and areas avoid each other
   
   // Map edge and centre constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0- rmZTilesToFraction (10), 0.01);
   int longPlayerEdgeConstraint=rmCreateBoxConstraint("long avoid edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0- rmZTilesToFraction(20), 0.01);
   int nearEdge = rmCreatePieConstraint("main forests stay near edge of map", 0.5, 0.5, rmGetMapXSize()-50, rmGetMapXSize()-20, rmDegreesToRadians(0), rmDegreesToRadians(360));
   int avoidEdge = rmCreatePieConstraint("sub forests stay away from edges", 0.5, 0.5, 0, rmXFractionToMeters(0.30), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // 1/4 slice of map constraints
   int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
   int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
   int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
   int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

   // Player avoidance
   int playerConstraintForest=rmCreateClassDistanceConstraint("main forests stay away from players", classPlayer, 10.0);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
   int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 20.0);

   // Resource avoidance
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
   int shortForestConstraint=rmCreateClassDistanceConstraint("natives avoid forest", rmClassID("classForest"), 8.0);
   int longForestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 40.0);
   int avoidSilver=rmCreateTypeDistanceConstraint("avoid silver mines", "Mine", 45.0);
   int shortAvoidSilver=rmCreateTypeDistanceConstraint("short avoid silver mines", "Mine", 5.0);
   int avoidTin=rmCreateTypeDistanceConstraint("avoid tin mines", "MineTin", 110.0);
   int shortAvoidTin=rmCreateTypeDistanceConstraint("short avoid tin mines", "MineTin", 5.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 10.0);

   // Terrain avoidance
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
   int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 10.0);
   int avoidCliffs=rmCreateClassDistanceConstraint("stuff avoids cliffs", classCliff, 10.0);

   // Unit and animal avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 45.0);
   int shortAvoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units short", rmClassID("startingUnit"), 10.0);
   int avoidNuggets=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 60.0);
   int animalConstraint=rmCreateClassDistanceConstraint("avoid all animals", classAnimals, 40.0);
   int avoidGoat=rmCreateTypeDistanceConstraint("herds avoids goat", "ypGoat", 35.0);
   int avoidBerry=rmCreateTypeDistanceConstraint("berries avoid berries", "Berrybush", 35.0);
   int avoidBear=rmCreateTypeDistanceConstraint("bears avoid bears", "PetBear", 35.0);

   // Native avoidance
   int avoidNatives=rmCreateClassDistanceConstraint("things avoids natives", rmClassID("natives"), 10.0);
   int farAvoidNatives=rmCreateClassDistanceConstraint("far things avoids natives", rmClassID("natives"), 40.0);
   int nativesAvoidNatives=rmCreateClassDistanceConstraint("natives avoids natives", rmClassID("natives"), 40.0);

   // Decoration avoidance
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

   // Area constraints
   int nativesMinPonds=rmCreateTerrainDistanceConstraint("natives stay little away from ponds", "Land", false, 20.0);
   int berryMinPonds=rmCreateTerrainDistanceConstraint("berries stay little away from ponds", "Land", false, 2.0);


   // Text
   rmSetStatusText("",0.10);


   // Define and place terrains - I wanted to make some kind of "utopic" like feeling

   // Cliffs to the edges - "Himalayas"
   int edgeCliffID=rmCreateArea("edge cliffs");
   rmSetAreaSize(edgeCliffID, 0.73, 0.73);
   rmSetAreaWarnFailure(edgeCliffID, false);
   rmSetAreaSmoothDistance(edgeCliffID, 10);
   rmSetAreaCoherence(edgeCliffID, 1.0);
   rmSetAreaLocation(edgeCliffID, 0.5, 0.5);
   rmSetAreaCliffType(edgeCliffID, "Himalayas");
   rmSetAreaCliffEdge(edgeCliffID, 1, 1.0, 0.0, 0.0, 0);
   rmSetAreaCliffHeight(edgeCliffID, -15, 0.0, 0.3);
   rmSetAreaCliffPainting(edgeCliffID, true, false, true);
   rmAddAreaToClass(edgeCliffID, classCliff);
   rmBuildArea(edgeCliffID);

   // "Normal terrain" - overwrites the Himalayas terrain, but still leaves the cliffs
   int greenID=rmCreateArea("green terrain");
   rmSetAreaSize(greenID, 0.7, 0.7);
   rmSetAreaWarnFailure(greenID, false);
   rmSetAreaSmoothDistance(greenID, 10);
   rmSetAreaMix(greenID, "borneo_grass_a");
   rmSetAreaTerrainType(greenID, "borneo\ground_grass1_borneo");
   rmSetAreaCoherence(greenID, 1.0);
   rmSetAreaLocation(greenID, 0.5, 0.5);
   rmBuildArea(greenID);


   // Text
   rmSetStatusText("",0.40);


   // Place players

   // Player placement if FFA (Free For All) - place players in circle

   if(cNumberTeams > 2)
   {
      rmSetTeamSpacingModifier(0.7);
      rmPlacePlayersCircular(0.33, 0.36, 0.0);
   }

   // Player placement if teams - place teams in circle to apart from each other

   if(cNumberTeams == 2)
   {
      rmSetPlacementTeam(0);
      rmSetPlacementSection(0.25, 0.5);
      rmSetTeamSpacingModifier(0.25);
      rmPlacePlayersCircular(0.33, 0.36, 0.0);

      rmSetPlacementTeam(1);
      rmSetPlacementSection(0.75, 1.0);
      rmSetTeamSpacingModifier(0.25);
      rmPlacePlayersCircular(0.33, 0.36, 0.0);
   }

   // Create the players area

   float playerFraction=rmAreaTilesToFraction(100);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmAddAreaConstraint(id, longAvoidImpassableLand);
      rmSetAreaLocPlayer(id, i);
      rmSetAreaWarnFailure(id, false);
   }

   // Build the areas.
   rmBuildAllAreas();


   // Text
   rmSetStatusText("",0.50);
		

   // Define starting objects and resources

   int startingTCID= rmCreateObjectDef("startingTC");
   if (rmGetNomadStart())
      rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);
   else
      rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
   rmAddObjectDefConstraint(startingTCID, avoidImpassableLand);
   rmAddObjectDefToClass(startingTCID, classPlayer);

   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));

   int startAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(startAreaTreeID, "TreeNewEngland", 6, 4.0);
   rmSetObjectDefMinDistance(startAreaTreeID, 14);
   rmSetObjectDefMaxDistance(startAreaTreeID, 16);
   rmAddObjectDefConstraint(startAreaTreeID, avoidStartResource);
   rmAddObjectDefConstraint(startAreaTreeID, avoidImpassableLand);
   rmAddObjectDefConstraint(startAreaTreeID, shortAvoidStartingUnits);

   int startAnimalsID=rmCreateObjectDef("starting animals");
   if (startAnimal == 1)
         rmAddObjectDefItem(startAnimalsID, "ypNilgai", 4, 4.0);
   else if (startAnimal == 2)
         rmAddObjectDefItem(startAnimalsID, "ypSerow", 4, 4.0);
   else if (startAnimal == 3)
         rmAddObjectDefItem(startAnimalsID, "ypMuskDeer", 4, 4.0);
   rmSetObjectDefCreateHerd(startAnimalsID, true);
   rmSetObjectDefMinDistance(startAnimalsID, 14);
   rmSetObjectDefMaxDistance(startAnimalsID, 16);
   rmAddObjectDefConstraint(startAnimalsID, avoidStartResource);
   rmAddObjectDefConstraint(startAnimalsID, avoidImpassableLand);

   int startSilverID = rmCreateObjectDef("player silver");
   rmAddObjectDefItem(startSilverID, "Mine", 1, 5.0);
   rmSetObjectDefMinDistance(startSilverID, 14);
   rmSetObjectDefMaxDistance(startSilverID, 16);
   rmAddObjectDefConstraint(startSilverID, avoidStartResource);
   rmAddObjectDefConstraint(startSilverID, avoidImpassableLand);
   rmAddObjectDefConstraint(startSilverID, shortAvoidStartingUnits);

   // Place starting objects and resources

   for(i=1; <cNumberPlayers)
   {					
      // Place starting objects and resources
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startAnimalsID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

      if(ypIsAsian(i) && rmGetNomadStart() == false)
            rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }


   // Define and place ponds

   // Pond 1 - to middle
   int pond1ID=rmCreateArea("Pond 1");
   rmSetAreaWaterType(pond1ID, "borneo water");
   rmSetAreaSize(pond1ID, 0.006, 0.006);
   rmSetAreaCoherence(pond1ID, 0.6);
   rmSetAreaLocation(pond1ID, 0.5, 0.5);
   rmSetAreaBaseHeight(pond1ID, -10.0);
   rmSetAreaObeyWorldCircleConstraint(pond1ID, false);
   rmSetAreaMinBlobs(pond1ID, 1);
   rmSetAreaMaxBlobs(pond1ID, 2);
   rmSetAreaMinBlobDistance(pond1ID, 1);
   rmSetAreaMaxBlobDistance(pond1ID, 2);
   rmSetAreaSmoothDistance(pond1ID, 2);
   rmBuildArea(pond1ID);

   // Pond 2 - further from middle
   int pond2ID=rmCreateArea("Pond 2");
   rmSetAreaWaterType(pond2ID, "borneo water");
   rmSetAreaSize(pond2ID, 0.006, 0.006);
   rmSetAreaCoherence(pond2ID, 0.6);
   if (pondPlace == 1)
   rmSetAreaLocation(pond2ID, 0.53, 0.7);
   else if (pondPlace == 2)
   rmSetAreaLocation(pond2ID, 0.7, 0.53);
   else if (pondPlace == 3)
   rmSetAreaLocation(pond2ID, 0.63, 0.63);
   else if (pondPlace == 4)
   rmSetAreaLocation(pond2ID, 0.63, 0.4);
   rmSetAreaBaseHeight(pond2ID, -10.0);
   rmSetAreaObeyWorldCircleConstraint(pond2ID, false);
   rmSetAreaMinBlobs(pond2ID, 1);
   rmSetAreaMaxBlobs(pond2ID, 2);
   rmSetAreaMinBlobDistance(pond2ID, 1);
   rmSetAreaMaxBlobDistance(pond2ID, 2);
   rmSetAreaSmoothDistance(pond2ID, 2);
   rmBuildArea(pond2ID);

   // Pond 3 - further from middle
   int pond3ID=rmCreateArea("Pond 3");
   rmSetAreaWaterType(pond3ID, "borneo water");
   rmSetAreaSize(pond3ID, 0.006, 0.006);
   rmSetAreaCoherence(pond3ID, 0.6);
   if (pondPlace == 1)
   rmSetAreaLocation(pond3ID, 0.47, 0.3);
   else if (pondPlace == 2)
   rmSetAreaLocation(pond3ID, 0.3, 0.47);
   else if (pondPlace == 3)
   rmSetAreaLocation(pond3ID, 0.37, 0.37);
   else if (pondPlace == 4)
   rmSetAreaLocation(pond3ID, 0.4, 0.63);
   rmSetAreaBaseHeight(pond3ID, -10.0);
   rmSetAreaObeyWorldCircleConstraint(pond3ID, false);
   rmSetAreaMinBlobs(pond3ID, 1);
   rmSetAreaMaxBlobs(pond3ID, 2);
   rmSetAreaMinBlobDistance(pond3ID, 1);
   rmSetAreaMaxBlobDistance(pond3ID, 2);
   rmSetAreaSmoothDistance(pond3ID, 2);
   rmBuildArea(pond3ID);


   // Place the 4 natives, all Sufi, Udasi or Bhakti - placed near each pond

   // Create constraints to tell natives to stay near ponds

   int native1Pond=rmCreateAreaMaxDistanceConstraint("native 1 near pond", pond1ID, 25.0);
   int native2Pond=rmCreateAreaMaxDistanceConstraint("native 2 near pond", pond2ID, 25.0);
   int native3Pond=rmCreateAreaMaxDistanceConstraint("native 3 near pond", pond3ID, 25.0);

   // Native 1

   int nativeVillageID = -1;
   int nativeVillageType = rmRandInt(1,5);
   if (subCiv0 == rmGetCivID("Bhakti"))
      nativeVillageID = rmCreateGrouping("bhakti village", "native bhakti village "+nativeVillageType);
   else if (subCiv0 == rmGetCivID("Sufi"))
      nativeVillageID = rmCreateGrouping("sufi village", "native sufi mosque borneo "+nativeVillageType);
   else if (subCiv0 == rmGetCivID("Udasi"))
      nativeVillageID = rmCreateGrouping("udasi village", "native udasi village "+nativeVillageType);
   rmSetGroupingMinDistance(nativeVillageID, rmXFractionToMeters(0.00));
   rmSetGroupingMaxDistance(nativeVillageID, rmXFractionToMeters(0.50));
   rmAddGroupingConstraint(nativeVillageID, shortForestConstraint);
   rmAddGroupingConstraint(nativeVillageID, animalConstraint);
   rmAddGroupingConstraint(nativeVillageID, playerConstraint);
   rmAddGroupingConstraint(nativeVillageID, shortAvoidSilver);
   rmAddGroupingConstraint(nativeVillageID, nativesAvoidNatives);
   rmAddGroupingConstraint(nativeVillageID, nativesMinPonds);
   rmAddGroupingConstraint(nativeVillageID, native1Pond);
   rmAddGroupingToClass(nativeVillageID, rmClassID("natives"));
   rmPlaceGroupingAtLoc(nativeVillageID, 0, 0.5, 0.5);

   // Native 2

   int nativeVillage2ID = -1;
   int nativeVillage2Type = rmRandInt(1,5);
   if (subCiv1 == rmGetCivID("Udasi")) 
      nativeVillage2ID = rmCreateGrouping("udasi village 2", "native udasi village "+nativeVillage2Type);
   else if (subCiv1 == rmGetCivID("Bhakti"))
      nativeVillage2ID = rmCreateGrouping("bhakti village 2", "native bhakti village "+nativeVillage2Type);
   else if (subCiv1 == rmGetCivID("Sufi"))
      nativeVillage2ID = rmCreateGrouping("sufi village 2", "native sufi mosque borneo "+nativeVillage2Type);
   rmSetGroupingMinDistance(nativeVillage2ID, rmXFractionToMeters(0.00));
   rmSetGroupingMaxDistance(nativeVillage2ID, rmXFractionToMeters(0.50));
   rmAddGroupingConstraint(nativeVillage2ID, shortForestConstraint);
   rmAddGroupingConstraint(nativeVillage2ID, animalConstraint);
   rmAddGroupingConstraint(nativeVillage2ID, playerConstraint);
   rmAddGroupingConstraint(nativeVillage2ID, shortAvoidSilver);
   rmAddGroupingConstraint(nativeVillage2ID, nativesAvoidNatives);
   rmAddGroupingConstraint(nativeVillage2ID, nativesMinPonds);
   rmAddGroupingConstraint(nativeVillage2ID, native2Pond);
   rmAddGroupingToClass(nativeVillage2ID, rmClassID("natives"));
   rmPlaceGroupingAtLoc(nativeVillage2ID, 0, 0.5, 0.5);

   // Native 3
  
   int nativeVillage3ID = -1;
   int nativeVillage3Type = rmRandInt(1,5);
   if (subCiv2 == rmGetCivID("Sufi"))
      nativeVillage3ID = rmCreateGrouping("sufi village 3", "native sufi mosque borneo "+nativeVillage3Type);
   else if (subCiv2 == rmGetCivID("Udasi"))
      nativeVillage3ID = rmCreateGrouping("udasi village 3", "native udasi village "+nativeVillage3Type);
   else if (subCiv2 == rmGetCivID("Bhakti"))
      nativeVillage3ID = rmCreateGrouping("bhakti village 3", "native bhakti village "+nativeVillage3Type);
   rmSetGroupingMinDistance(nativeVillage3ID, rmXFractionToMeters(0.00));
   rmSetGroupingMaxDistance(nativeVillage3ID, rmXFractionToMeters(0.50));
   rmAddGroupingConstraint(nativeVillage3ID, shortForestConstraint);
   rmAddGroupingConstraint(nativeVillage3ID, animalConstraint);
   rmAddGroupingConstraint(nativeVillage3ID, playerConstraint);
   rmAddGroupingConstraint(nativeVillage3ID, shortAvoidSilver);
   rmAddGroupingConstraint(nativeVillage3ID, nativesAvoidNatives);
   rmAddGroupingConstraint(nativeVillage3ID, nativesMinPonds);
   rmAddGroupingConstraint(nativeVillage3ID, native3Pond);
   rmAddGroupingToClass(nativeVillage3ID, rmClassID("natives"));
   rmPlaceGroupingAtLoc(nativeVillage3ID, 0, 0.5, 0.5);

   // Native 4
 
   int nativeVillage4ID = -1;
   int nativeVillage4Type = rmRandInt(1,5);
   if (subCiv3 == rmGetCivID("Bhakti"))
      nativeVillage4ID = rmCreateGrouping("bhakti village 4", "native bhakti village "+nativeVillage4Type);
   else if (subCiv3 == rmGetCivID("Sufi"))
      nativeVillage4ID = rmCreateGrouping("sufi village 4", "native sufi mosque borneo "+nativeVillage4Type);
   else if (subCiv3 == rmGetCivID("Udasi"))
      nativeVillage4ID = rmCreateGrouping("udasi village 4", "native udasi village "+nativeVillage4Type);
   rmSetGroupingMinDistance(nativeVillage4ID, rmXFractionToMeters(0.00));
   rmSetGroupingMaxDistance(nativeVillage4ID, rmXFractionToMeters(0.50));
   rmAddGroupingConstraint(nativeVillage4ID, shortForestConstraint);
   rmAddGroupingConstraint(nativeVillage4ID, animalConstraint);
   rmAddGroupingConstraint(nativeVillage4ID, playerConstraint);
   rmAddGroupingConstraint(nativeVillage4ID, shortAvoidSilver);
   rmAddGroupingConstraint(nativeVillage4ID, nativesAvoidNatives);
   rmAddGroupingConstraint(nativeVillage4ID, nativesMinPonds);
   if (nearPond == 1)
   rmAddGroupingConstraint(nativeVillage4ID, native1Pond);
   else if (nearPond == 2)
   rmAddGroupingConstraint(nativeVillage4ID, native2Pond);
   else if (nearPond == 3)
   rmAddGroupingConstraint(nativeVillage4ID, native3Pond);
   rmAddGroupingToClass(nativeVillage4ID, rmClassID("natives"));
   rmPlaceGroupingAtLoc(nativeVillage4ID, 0, 0.5, 0.5);


   // Text
   rmSetStatusText("",0.60);
   int numTries = -1;
   int failCount = -1;


   // Text
   rmSetStatusText("",0.70);


   // Define and place forests
	
   // Many forests to edges
   numTries=6*cNumberNonGaiaPlayers;
   failCount=0;
   for (i=0; <numTries)
   {   
      int edgeForestID=rmCreateArea("edgeforest"+i);
      rmSetAreaWarnFailure(edgeForestID, false);
      rmSetAreaSize(edgeForestID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(400));
      rmSetAreaForestType(edgeForestID, "new england forest");
      rmSetAreaForestDensity(edgeForestID, 1.0);
      rmAddAreaToClass(edgeForestID, rmClassID("classForest"));
      rmSetAreaForestClumpiness(edgeForestID, 1.0);
      rmSetAreaForestUnderbrush(edgeForestID, 0.3);
      rmSetAreaBaseHeight(edgeForestID, -11.0);
      rmSetAreaMinBlobs(edgeForestID, 1);
      rmSetAreaMaxBlobs(edgeForestID, 3);
      rmSetAreaMinBlobDistance(edgeForestID, 5.0);
      rmSetAreaMaxBlobDistance(edgeForestID, 10.0);
      rmSetAreaCoherence(edgeForestID, 0.4);
      rmSetAreaSmoothDistance(edgeForestID, 1);
      rmAddAreaConstraint(edgeForestID, avoidImpassableLand);
      rmAddAreaConstraint(edgeForestID, playerConstraintForest);
      rmAddAreaConstraint(edgeForestID, nearEdge);
      rmAddAreaConstraint(edgeForestID, forestConstraint);
      rmAddAreaConstraint(edgeForestID, avoidNatives);
      if(rmBuildArea(edgeForestID)==false)
      {
            // Stop trying once we fail 5 times in a row.  
            failCount++;
            if(failCount==5)
                        break;
      }
      else
            failCount=0; 
   }

   // Only few forests to middle
   numTries=2*cNumberNonGaiaPlayers;
   failCount=0;
   for (i=0; <numTries)
   {   
      int centreForestID=rmCreateArea("centreforest"+i);
      rmSetAreaWarnFailure(centreForestID, false);
      rmSetAreaSize(centreForestID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
      rmSetAreaForestType(centreForestID, "new england forest");
      rmSetAreaForestDensity(centreForestID, 0.1);
      rmAddAreaToClass(centreForestID, rmClassID("classForest"));
      rmSetAreaForestClumpiness(centreForestID, 0.4);
      rmSetAreaForestUnderbrush(centreForestID, 0.3);
      rmSetAreaBaseHeight(centreForestID, -11.0);
      rmSetAreaMinBlobs(centreForestID, 1);
      rmSetAreaMaxBlobs(centreForestID, 3);
      rmSetAreaMinBlobDistance(centreForestID, 5.0);
      rmSetAreaMaxBlobDistance(centreForestID, 10.0);
      rmSetAreaCoherence(centreForestID, 0.4);
      rmSetAreaSmoothDistance(centreForestID, 1);
      rmAddAreaConstraint(centreForestID, avoidImpassableLand);
      rmAddAreaConstraint(centreForestID, shortPlayerConstraint);
      rmAddAreaConstraint(centreForestID, avoidEdge);
      rmAddAreaConstraint(centreForestID, avoidNatives);
      rmAddAreaConstraint(centreForestID, longForestConstraint);
      if(rmBuildArea(centreForestID)==false)
      {
            // Stop trying once we fail 5 times in a row.  
            failCount++;
            if(failCount==5)
                        break;
      }
      else
            failCount=0; 
   }


   // Text
   rmSetStatusText("",0.80);


   // Define and place huntables - these are all real animals in Kashmir!
   
   // Muskdeer herds

   int muskDeerHerdID=rmCreateObjectDef("muskdeer herd");
   rmAddObjectDefItem(muskDeerHerdID, "ypMuskDeer", rmRandInt(2,4), 6.0);
   rmSetObjectDefCreateHerd(muskDeerHerdID, true);
   rmSetObjectDefMinDistance(muskDeerHerdID, 0.0);
   rmSetObjectDefMaxDistance(muskDeerHerdID, rmXFractionToMeters(0.45));
   rmAddObjectDefToClass(muskDeerHerdID, classAnimals);
   rmAddObjectDefConstraint(muskDeerHerdID, shortAvoidSilver);
   rmAddObjectDefConstraint(muskDeerHerdID, avoidNatives);
   rmAddObjectDefConstraint(muskDeerHerdID, shortAvoidTin);
   rmAddObjectDefConstraint(muskDeerHerdID, shortPlayerConstraint);
   rmAddObjectDefConstraint(muskDeerHerdID, avoidAll);
   rmAddObjectDefConstraint(muskDeerHerdID, avoidImpassableLand);
   rmAddObjectDefConstraint(muskDeerHerdID, animalConstraint);
   numTries=2*cNumberNonGaiaPlayers;
   for (i=0; <numTries)
   {
      rmPlaceObjectDefAtLoc(muskDeerHerdID, 0, 0.5, 0.5);
   }


   // Serow herds

   int serowHerdID=rmCreateObjectDef("serow herd");
   rmAddObjectDefItem(serowHerdID, "ypSerow", rmRandInt(3,4), 6.0);
   rmSetObjectDefCreateHerd(serowHerdID, true);
   rmSetObjectDefMinDistance(serowHerdID, 0.0);
   rmSetObjectDefMaxDistance(serowHerdID, rmXFractionToMeters(0.45));
   rmAddObjectDefToClass(serowHerdID, classAnimals);
   rmAddObjectDefConstraint(serowHerdID, shortAvoidSilver);
   rmAddObjectDefConstraint(serowHerdID, avoidNatives);
   rmAddObjectDefConstraint(serowHerdID, shortAvoidTin);
   rmAddObjectDefConstraint(serowHerdID, shortPlayerConstraint);
   rmAddObjectDefConstraint(serowHerdID, avoidAll);
   rmAddObjectDefConstraint(serowHerdID, avoidImpassableLand);
   rmAddObjectDefConstraint(serowHerdID, animalConstraint);
   numTries=cNumberNonGaiaPlayers;
   for (i=0; <numTries)
   {
      rmPlaceObjectDefAtLoc(serowHerdID, 0, 0.5, 0.5);
   }

   // Nilgai herds

   int nilgaiHerdID=rmCreateObjectDef("nilgai herd");
   rmAddObjectDefItem(nilgaiHerdID, "ypNilgai", rmRandInt(2,3), 6.0);
   rmSetObjectDefCreateHerd(nilgaiHerdID, true);
   rmSetObjectDefMinDistance(nilgaiHerdID, 0.0);
   rmSetObjectDefMaxDistance(nilgaiHerdID, rmXFractionToMeters(0.45));
   rmAddObjectDefToClass(nilgaiHerdID, classAnimals);
   rmAddObjectDefConstraint(nilgaiHerdID, shortAvoidSilver);
   rmAddObjectDefConstraint(nilgaiHerdID, avoidNatives);
   rmAddObjectDefConstraint(nilgaiHerdID, shortAvoidTin);
   rmAddObjectDefConstraint(nilgaiHerdID, shortPlayerConstraint);
   rmAddObjectDefConstraint(nilgaiHerdID, avoidAll);
   rmAddObjectDefConstraint(nilgaiHerdID, avoidImpassableLand);
   rmAddObjectDefConstraint(nilgaiHerdID, animalConstraint);
   numTries=2*cNumberNonGaiaPlayers;
   for (i=0; <numTries)
   {
      rmPlaceObjectDefAtLoc(nilgaiHerdID, 0, 0.5, 0.5);
   }


   // Define and place mines

   // Many silver mines to middle
   int silverID = -1;
   int silverCount = (2*cNumberNonGaiaPlayers);

   for(i=0; < silverCount)
   {
      silverID = rmCreateObjectDef("silver mine "+i);
      rmAddObjectDefItem(silverID, "mine", 1, 0.0);
      rmSetObjectDefMinDistance(silverID, 0.0);
      rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.20));
      rmAddObjectDefConstraint(silverID, avoidImpassableLand);
      rmAddObjectDefConstraint(silverID, playerConstraint);
      rmAddObjectDefConstraint(silverID, avoidSilver);
      rmAddObjectDefConstraint(silverID, avoidNatives);
      rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5);
   }

   // Only few tin mines to edges
   int tinID = -1;
   int tinCount = (rmRandInt(2,3));

   for(i=0; < tinCount)
   {
      tinID = rmCreateObjectDef("tin mine "+i);
      rmAddObjectDefItem(tinID, "MineTin", 1, 0.0);
      rmSetObjectDefMinDistance(tinID, rmXFractionToMeters(0.40));
      rmSetObjectDefMaxDistance(tinID, rmXFractionToMeters(0.45));
      rmAddObjectDefConstraint(tinID, avoidImpassableLand);
      rmAddObjectDefConstraint(tinID, shortPlayerConstraint);
      rmAddObjectDefConstraint(tinID, avoidTin);
      rmPlaceObjectDefAtLoc(tinID, 0, 0.5, 0.5);
   }


   // Text
   rmSetStatusText("",0.90);


   // Text
   rmSetStatusText("",0.99);


   // Define and place nuggets

   // Easy nuggets
   int nugget1= rmCreateObjectDef("nugget easy"); 
   rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(1, 1);
   rmAddObjectDefToClass(nugget1, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nugget1, 0.0);
   rmSetObjectDefMaxDistance(nugget1, rmXFractionToMeters(0.45));
   rmAddObjectDefConstraint(nugget1, shortPlayerConstraint);
   rmAddObjectDefConstraint(nugget1, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget1, avoidNuggets);
   rmAddObjectDefConstraint(nugget1, avoidNatives);
   rmAddObjectDefConstraint(nugget1, avoidAll);
   rmPlaceObjectDefAtLoc(nugget1, 0, 0.5, 0.5, cNumberNonGaiaPlayers);

   // Medium nuggets
   int nugget2= rmCreateObjectDef("nugget medium"); 
   rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefToClass(nugget2, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nugget2, 0.0);
   rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.45));
   rmAddObjectDefConstraint(nugget2, shortPlayerConstraint);
   rmAddObjectDefConstraint(nugget2, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget2, avoidNuggets);
   rmAddObjectDefConstraint(nugget2, avoidNatives);
   rmAddObjectDefConstraint(nugget2, avoidAll);
   rmPlaceObjectDefAtLoc(nugget2, 0, 0.5, 0.5, cNumberNonGaiaPlayers);

   // Hard nuggets
   int nugget3= rmCreateObjectDef("nugget hard"); 
   rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefToClass(nugget3, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nugget3, 0.0);
   rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.45));
   rmAddObjectDefConstraint(nugget3, shortPlayerConstraint);
   rmAddObjectDefConstraint(nugget3, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget3, avoidNuggets);
   rmAddObjectDefConstraint(nugget3, avoidNatives);
   rmAddObjectDefConstraint(nugget3, avoidAll);
   rmPlaceObjectDefAtLoc(nugget3, 0, 0.5, 0.5, rmRandInt(2,4));

   // Nut nuggets - not sure what these are, maybe very hard
   int nugget4= rmCreateObjectDef("nugget nuts"); 
   rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(4, 4);
   rmAddObjectDefToClass(nugget4, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nugget4, 0.0);
   rmSetObjectDefMaxDistance(nugget4, rmXFractionToMeters(0.45));
   rmAddObjectDefConstraint(nugget4, playerConstraint);
   rmAddObjectDefConstraint(nugget4, avoidImpassableLand);
   rmAddObjectDefConstraint(nugget4, avoidNuggets);
   rmAddObjectDefConstraint(nugget4, avoidNatives);
   rmAddObjectDefConstraint(nugget4, avoidAll);
   rmPlaceObjectDefAtLoc(nugget4, 0, 0.5, 0.5, rmRandInt(2,3));


   // Define and place goat herds - try to get cashmeer wool of them! :P
   int goatID=rmCreateObjectDef("goat");
   rmAddObjectDefItem(goatID, "ypGoat", 2, 4.0);
   rmSetObjectDefMinDistance(goatID, 0.0);
   rmSetObjectDefMaxDistance(goatID, rmXFractionToMeters(0.45));
   rmAddObjectDefConstraint(goatID, avoidGoat);
   rmAddObjectDefConstraint(goatID, avoidAll);
   rmAddObjectDefConstraint(goatID, avoidNatives);
   rmAddObjectDefConstraint(goatID, playerConstraint);
   rmAddObjectDefConstraint(goatID, avoidImpassableLand);
   rmPlaceObjectDefAtLoc(goatID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);


   // Define and place berrybushes near ponds

   // Create constraints to tell berries to be near ponds

   int berry1Pond=rmCreateAreaMaxDistanceConstraint("berry near pond 1", pond1ID, 2.0);
   int berry2Pond=rmCreateAreaMaxDistanceConstraint("berry near pond 2", pond2ID, 2.0);
   int berry3Pond=rmCreateAreaMaxDistanceConstraint("berry near pond 3", pond3ID, 2.0);

   // Define and place berries to near pond 1
   int berry1ID=rmCreateObjectDef("berry 1");
   rmAddObjectDefItem(berry1ID, "Berrybush", 1, 7.0);
   rmSetObjectDefMinDistance(berry1ID, 0.0);
   rmSetObjectDefMaxDistance(berry1ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(berry1ID, avoidBerry);
   rmAddObjectDefConstraint(berry1ID, avoidNatives);
   rmAddObjectDefConstraint(berry1ID, berryMinPonds);
   rmAddObjectDefConstraint(berry1ID, berry1Pond);
   rmPlaceObjectDefAtLoc(berry1ID, 0, 0.5, 0.5, rmRandInt(4,6));

   // Define and place berries to near pond 2
   int berry2ID=rmCreateObjectDef("berry 2");
   rmAddObjectDefItem(berry2ID, "Berrybush", 1, 7.0);
   rmSetObjectDefMinDistance(berry2ID, 0.0);
   rmSetObjectDefMaxDistance(berry2ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(berry2ID, avoidBerry);
   rmAddObjectDefConstraint(berry2ID, avoidNatives);
   rmAddObjectDefConstraint(berry2ID, berryMinPonds);
   rmAddObjectDefConstraint(berry2ID, berry2Pond);
   rmPlaceObjectDefAtLoc(berry2ID, 0, 0.5, 0.5, rmRandInt(4,6));

   // Define and place berries to near pond 3
   int berry3ID=rmCreateObjectDef("berry 3");
   rmAddObjectDefItem(berry3ID, "Berrybush", 1, 7.0);
   rmSetObjectDefMinDistance(berry3ID, 0.0);
   rmSetObjectDefMaxDistance(berry3ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(berry3ID, avoidBerry);
   rmAddObjectDefConstraint(berry3ID, avoidNatives);
   rmAddObjectDefConstraint(berry3ID, berryMinPonds);
   rmAddObjectDefConstraint(berry3ID, berry3Pond);
   rmPlaceObjectDefAtLoc(berry3ID, 0, 0.5, 0.5, rmRandInt(4,6));

   // Define and place black bears around the map!
   int bearID=rmCreateObjectDef("black bear");
   rmAddObjectDefItem(bearID, "PetBear", 1, 5.0);
   rmSetObjectDefMinDistance(bearID, 0.0);
   rmSetObjectDefMaxDistance(bearID, rmXFractionToMeters(0.45));
   rmAddObjectDefConstraint(bearID, avoidNatives);
   rmAddObjectDefConstraint(bearID, avoidBear);
   rmAddObjectDefConstraint(bearID, playerConstraint);
   rmAddObjectDefConstraint(bearID, avoidImpassableLand);
   if (cNumberNonGaiaPlayers <= 4)
      rmPlaceObjectDefAtLoc(bearID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
   else
      rmPlaceObjectDefAtLoc(bearID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);


   // Define and place water decorations to ponds

   // Create constraints to tell deco families to stay in ponds
   int deco1Pond=rmCreateAreaConstraint("deco in pond 1", pond1ID);
   int deco2Pond=rmCreateAreaConstraint("deco in pond 2", pond2ID);
   int deco3Pond=rmCreateAreaConstraint("deco in pond 3", pond3ID);

   // Define and place duck family to pond 1
   int duck1ID=rmCreateObjectDef("duck family 1");
   rmAddObjectDefItem(duck1ID, "DuckFamily", 1, 1.0);
   rmSetObjectDefMinDistance(duck1ID, 0.0);
   rmSetObjectDefMaxDistance(duck1ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(duck1ID, deco1Pond);
   rmPlaceObjectDefAtLoc(duck1ID, 0, 0.5, 0.5, 3);

   // Define and place duck family to pond 2
   int duck2ID=rmCreateObjectDef("duck family 2");
   rmAddObjectDefItem(duck2ID, "DuckFamily", 1, 1.0);
   rmSetObjectDefMinDistance(duck2ID, 0.0);
   rmSetObjectDefMaxDistance(duck2ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(duck2ID, deco2Pond);
   rmPlaceObjectDefAtLoc(duck2ID, 0, 0.5, 0.5, 3);

   // Define and place duck family to pond 3
   int duck3ID=rmCreateObjectDef("duck family 3");
   rmAddObjectDefItem(duck3ID, "DuckFamily", 1, 1.0);
   rmSetObjectDefMinDistance(duck3ID, 0.0);
   rmSetObjectDefMaxDistance(duck3ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(duck3ID, deco3Pond);
   rmPlaceObjectDefAtLoc(duck3ID, 0, 0.5, 0.5, 3);

   // Define and place plants to pond 1
   int plants1ID=rmCreateObjectDef("plants 1");
   rmAddObjectDefItem(plants1ID, "LakeWaterPlantsNe", 1, 1.0);
   rmSetObjectDefMinDistance(plants1ID, 0.0);
   rmSetObjectDefMaxDistance(plants1ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(plants1ID, deco1Pond);
   rmPlaceObjectDefAtLoc(plants1ID, 0, 0.5, 0.5, 6);

   // Define and place plants to pond 2
   int plants2ID=rmCreateObjectDef("plants 2");
   rmAddObjectDefItem(plants2ID, "LakeWaterPlantsNe", 1, 1.0);
   rmSetObjectDefMinDistance(plants2ID, 0.0);
   rmSetObjectDefMaxDistance(plants2ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(plants2ID, deco2Pond);
   rmPlaceObjectDefAtLoc(plants2ID, 0, 0.5, 0.5, 6);

   // Define and place plants to pond 3
   int plants3ID=rmCreateObjectDef("plants 3");
   rmAddObjectDefItem(plants3ID, "LakeWaterPlantsNe", 1, 1.0);
   rmSetObjectDefMinDistance(plants3ID, 0.0);
   rmSetObjectDefMaxDistance(plants3ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(plants3ID, deco3Pond);
   rmPlaceObjectDefAtLoc(plants3ID, 0, 0.5, 0.5, 6);

   // Define and place turtles to pond 1
   int turtles1ID=rmCreateObjectDef("turtles 1");
   rmAddObjectDefItem(turtles1ID, "PropTurtles", 1, 1.0);
   rmSetObjectDefMinDistance(turtles1ID, 0.0);
   rmSetObjectDefMaxDistance(turtles1ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(turtles1ID, deco1Pond);
   rmPlaceObjectDefAtLoc(turtles1ID, 0, 0.5, 0.5, 2);

   // Define and place turtles to pond 2
   int turtles2ID=rmCreateObjectDef("turtles 2");
   rmAddObjectDefItem(turtles2ID, "PropTurtles", 1, 1.0);
   rmSetObjectDefMinDistance(turtles2ID, 0.0);
   rmSetObjectDefMaxDistance(turtles2ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(turtles2ID, deco2Pond);
   rmPlaceObjectDefAtLoc(turtles2ID, 0, 0.5, 0.5, 2);

   // Define and place turtles to pond 3
   int turtles3ID=rmCreateObjectDef("turtles 3");
   rmAddObjectDefItem(turtles3ID, "PropTurtles", 1, 1.0);
   rmSetObjectDefMinDistance(turtles3ID, 0.0);
   rmSetObjectDefMaxDistance(turtles3ID, rmXFractionToMeters(0.50));
   rmAddObjectDefConstraint(turtles3ID, deco3Pond);
   rmPlaceObjectDefAtLoc(turtles3ID, 0, 0.5, 0.5, 2);


   // Place King's Hill if KOTH game to middle - is automatically avoids the ponds and places near it
   if(rmGetIsKOTH()) 
   {
      int randLoc = rmRandInt(1,2);
      float xLoc = 0.5;
      float yLoc = 0.5;
      float walk = 0.05;
    
      ypKingsHillPlacer(xLoc, yLoc, walk, 0);
      rmEchoInfo("XLOC = "+xLoc);
      rmEchoInfo("XLOC = "+yLoc);
   }	


   // Text
   rmSetStatusText("",1.0);
}  
